%global dlrn_nvr metalsmith-1.4.4-1.20230515184003.5e7461e
%global dlrn 1
%define upstream_version 1.4.4
%{!?sources_gpg: %{!?dlrn:%global sources_gpg 1} }
%global sources_gpg_sign 0xa63ea142678138d1bb15f2e303bdfd64dd164087
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%global with_doc 0
%global sname metalsmith

%global common_summary Bare metal provisioner using Ironic
%global common_desc Simple Python library and CLI tool to \
provision bare metal machines using OpenStack Ironic.
%global common_desc_tests Tests for metalsmith.

Name: python-%{sname}
Version: 1.4.4
Release: 1.20230515184003.5e7461e%{?dist}
Summary: %{common_summary}
License: ASL 2.0
URL: https://docs.openstack.org/metalsmith/latest/

Source0: metalsmith-1.4.4-1.20230515184003.5e7461e.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=5e7461e9d2d4156390c4809654094a26148fb054
Patch0001: 0001-list_instances-cache-allocations.patch

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
Source101:        http://tarballs.openstack.org/%{sname}/%{sname}-%{upstream_version}.tar.gz.asc
Source102:        https://releases.openstack.org/_static/%{sources_gpg_sign}.txt
%endif

BuildArch: noarch

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
BuildRequires:  /usr/bin/gpgv2
BuildRequires: openstack-macros
%endif

%description
%{common_desc}

%package -n python3-%{sname}
Summary: %{common_summary}
%{?python_provide:%python_provide python3-%{sname}}
Obsoletes: python2-%{sname} < %{version}-%{release}

BuildRequires: git-core
BuildRequires: openstack-macros
BuildRequires: python3-devel
BuildRequires: python3-pbr
BuildRequires: python3-setuptools
# Required for running unit tests
BuildRequires: python3-mock
BuildRequires: python3-openstacksdk
BuildRequires: python3-prettytable
BuildRequires: python3-stestr
BuildRequires: python3-testtools
BuildRequires: python3-requests
BuildRequires: (python3dist(ansible) >= 2.6 or ansible-core >= 2.11)

Requires: python3-openstacksdk >= 0.29.0
Requires: python3-pbr >= 2.0.0
Requires: python3-prettytable >= 0.7.2
Requires: python3-requests >= 2.18.4


Requires(pre): shadow-utils

%description -n python3-%{sname}
%{common_desc}

%package -n python3-%{sname}-tests
Summary: metalsmith tests
Requires: python3-%{sname} = %{version}-%{release}
Requires: python3-mock
Requires: python3-testtools
Requires: (python3dist(ansible) >= 2.6 or ansible-core >= 2.11)

%description -n python3-%{sname}-tests
%{common_desc_tests}

%if 0%{?with_doc}
%package -n python-%{sname}-doc
Summary: %{common_summary} - documentation

BuildRequires: python3-sphinx
BuildRequires: python3-openstackdocstheme
BuildRequires: python3-sphinxcontrib-apidoc
BuildRequires: python3-sphinxcontrib-rsvgconverter

%description -n python-%{sname}-doc
%{common_summary}

This package contains documentation.
%endif

%package -n ansible-role-%{sname}-deployment
Summary: %{common_summary} - ansible role

# The ansible role uses CLI which is currently provided by the Python 2
# package. Change this when the CLI is provided by the Python 3 package.
Requires: python3-%{sname} = %{version}-%{release}
Requires: (python3dist(ansible) >= 2.9 or ansible-core >= 2.11)
Requires: ansible-collections-openstack

%description -n ansible-role-%{sname}-deployment
%{common_summary}

This package contains the metalsmith_deployment role to use metalsmith
in ansible playbooks.

%prep
# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
%{gpgverify}  --keyring=%{SOURCE102} --signature=%{SOURCE101} --data=%{SOURCE0}
%endif
%autosetup -n %{sname}-%{upstream_version} -S git

# Let's handle dependencies ourseleves
%py_req_cleanup

# remove shebangs and fix permissions
if [ -f metalsmith_ansible/ansible_plugins/modules/metalsmith_instances.py ]; then
  sed -i '1{/^#!/d}' metalsmith_ansible/ansible_plugins/modules/metalsmith_instances.py
  chmod u=rw,go=r metalsmith_ansible/ansible_plugins/modules/metalsmith_instances.py
fi


%build
%{py3_build}

%if 0%{?with_doc}
# generate html docs
sphinx-build-3 -b html doc/source doc/build/html
# remove the sphinx-build-3 leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

%install
%{py3_install}

if [ ! -d %{buildroot}%{_datadir}/ansible/plugins ]; then
  mkdir -p %{buildroot}%{_datadir}/ansible/plugins
fi

# Create a versioned binary for backwards compatibility until everything is pure py3
ln -s metalsmith %{buildroot}%{_bindir}/metalsmith-3

%check
PYTHON=%{__python3} stestr-3 run

%files -n python3-%{sname}
%license LICENSE
%{_bindir}/metalsmith
%{_bindir}/metalsmith-3
%{python3_sitelib}/%{sname}
%{python3_sitelib}/%{sname}-*.egg-info
%exclude %{python3_sitelib}/%{sname}/test

%files -n python3-%{sname}-tests
%license LICENSE
%{python3_sitelib}/%{sname}/test

%if 0%{?with_doc}
%files -n python-%{sname}-doc
%license LICENSE
%doc doc/build/html README.rst
%endif

%files -n ansible-role-%{sname}-deployment
%license LICENSE
%doc README.rst
%{_datadir}/ansible/roles/metalsmith_deployment
%{_datadir}/ansible/plugins
%exclude %{_datadir}/ansible/roles/metalsmith_deployment/README.rst

%changelog
* Mon May 15 2023 OSP Prod Chain <dev-null@redhat.com> 1.4.4-1.20230515184003.5e7461e
- list_instances - cache allocations (rhbz#2166865)

* Thu Apr 20 2023 OSP Prod Chain <dev-null@redhat.com> 1.4.4-1.20230420044118.5e7461e
- Update patches

* Mon Mar 20 2023 OSP Prod Chain <dev-null@redhat.com> 1.4.4-1.20230320135330.5e7461e
- Update patches

* Thu Sep 01 2022 OSP Prod Chain <dev-null@redhat.com> 1.4.4-1.20220901073724.5e7461e
- Update patches
- Do a precise node lookup for unprovision
- Add linters job
- metalsmith_instances module, unprovision by hostname
- metalsmith_instances module, pass hostname in reserve
- metalsmith list handle missing port
- Add a workaround to fix the CI
- Ensure tox.ini is ASCII
- Avoid non-Stream CentOS 8, it is EOL; make one job non-voting

* Wed Jul 27 2022 OSP Prod Chain <dev-null@redhat.com> 1.4.3-1.20220727222604.324b758
- Do a precise node lookup for unprovision (rhbz#2092444)

* Tue Jul 12 2022 OSP Prod Chain <dev-null@redhat.com> 1.4.3-0.20220712110234.324b758
- metalsmith_instances module, unprovision by hostname (rhbz#2092444)
- metalsmith_instances module, pass hostname in reserve
- metalsmith list handle missing port (rhbz#2092444)

* Tue Feb 22 2022 OSP Prod Chain <dev-null@redhat.com> 1.4.3-0.20220223022359.324b758
- Ensure tox.ini is ASCII

* Fri Dec 10 2021 OSP Prod Chain <dev-null@redhat.com> 1.4.3-0.20211210121855.324b758
- Update patches
- Set binding:host_id on VIFs
- Write network_data.json metadata to config-dirve
- Replace deprecated import of ABCs from collections
- Update TOX_CONSTRAINTS_FILE for stable/wallaby
- Update .gitreview for stable/wallaby

* Thu Nov 18 2021 OSP Prod Chain <dev-null@redhat.com> 1.4.2-0.20211119041904.347e756
- Update patches

* Wed Sep 08 2021 OSP Prod Chain <dev-null@redhat.com> 1.4.2-0.20210908095210.347e756
- Update patches

* Fri May 28 2021 OSP Prod Chain <dev-null@redhat.com> 1.4.2-0.20210528111939.347e756
- Update patches

* Thu May 13 2021 OSP Prod Chain <dev-null@redhat.com> 1.4.2-0.20210513052913.347e756
- Update patches

* Fri May 07 2021 OSP Prod Chain <dev-null@redhat.com> 1.4.2-0.20210507132719.347e756
- Update patches
- Fix release versions
- Uncap PrettyTable
- Change metalsmith to centos8+uefi job by default
- Do not wipe instance_info on normal unprovisioning
- Remove lower-constraints job
- Update TOX_CONSTRAINTS_FILE
- Move pep8 requirements to tox.ini
- Follow-up to metalsmith_instances config_drive
- Add metalsmith_instances instance option config_drive


